<template lang="pug">
  div(class="blog-list__item")
    div(:class="!document.isDraft ? 'hidden': 'blog-list__item__draft'")
      div
      IconHandPalm
      div {{ $t('error.articlePendingApproval') }}
    div(class="blog-list__item__header")
      div(class="blog-list__item__header__category")
        span {{ document.category }}
      div(class="blog-list__item__header__statistics")
        IconPenNib(class="blog-list__item__header__statistics__icon")/
        span {{ $tc('label.wordCount', Math.ceil(document.readingTime.words)) }}
        IconTimer(class="blog-list__item__header__statistics__icon")/
        span {{ $tc('label.readingTime', Math.ceil(document.readingTime.minutes)) }}
    div(class="blog-list__item__body mb-8")
      p(class="text-2xl mb-2")
        img(v-if="document.image" :src="document.image")
        span {{ document.title }}
      div {{ document.description }}
    div(class="blog-list__item__footer")
      a(v-for="(availablePath, availableLocale) in availableArticleLocales()" :href="availablePath")
        IconTranslate(class="blog-list__item__footer__icon mr-1 text-blue-300")/
        span {{ $t("label.locales." + availableLocale) }}
      IconCalendarBlank(class="blog-list__item__footer__icon")/
      span() {{ $moment(document.createdAt).format('ll') }}
      IconHandPointingRight(v-if="!document.isDraft" class="blog-list__item__footer__icon")/
      a(v-if="!document.isDraft" :href="localePath(document.path)") {{ $t('label.readMore') }}
</template>

<script>
import IconClockClockwise from '~/assets/svg/ph-clock-clockwise-fill.svg?inline';
import IconArrowCircleDownRight from '~/assets/svg/ph-arrow-circle-down-right-fill.svg?inline';
import IconHandPointingRight from '~/assets/svg/ph-hand-pointing-fill.svg?inline';
import IconTimer from '~/assets/svg/ph-timer-fill.svg?inline';
import IconPenNib from '~/assets/svg/ph-pen-nib-fill.svg?inline';
import IconCalendarBlank from '~/assets/svg/ph-calendar-blank-fill.svg?inline';
import IconTranslate from '~/assets/svg/ph-translate-fill.svg?inline';
import IconHandPalm from '~/assets/svg/ph-hand-palm-fill.svg?inline';

export default {
  name:       "BlogListItem",
  components: {
    IconClockClockwise,
    IconArrowCircleDownRight,
    IconHandPointingRight,
    IconTimer,
    IconPenNib,
    IconCalendarBlank,
    IconTranslate,
    IconHandPalm,
  },
  props:      {
    document: Object,
  },
  methods:    {
    availableArticleLocales() {
      let locales = []
      let path = {}

      this.$i18n.availableLocales.forEach(locale => {
        if (locale !== this.$i18n.locale) {
          locales.push(locale)
        }
      })

      locales.forEach(locale => {
        let myPath = this.document.path

        if (this.document.language.includes(locale)) {
          path[locale] = myPath.replace(/^(\/[a-zA-Z]{2})/, '/' + locale)
        }
      })

      return path
    }
  }
}
</script>

<style lang="scss" scoped>
.blog-list {
  &__item {
    @apply
    shadow
    dark:shadow-xl
    bg-gray-100
    dark:bg-gray-600
    bg-opacity-90
    dark:bg-opacity-90
    rounded
    p-2
    m-2
      mb-2
    sm:mt-0
    sm:ml-0
    sm:mr-0
    text-gray-600
    dark:text-gray-400
    relative
    hover:ring-gray-500
    ;

    &__draft {
      @apply
      backdrop-blur-sm
      select-none
      absolute
      top-0
      left-0
      right-0
      bottom-0
      w-full
      h-full
      z-50
      overflow-hidden
      bg-gray-200
      dark:bg-gray-700
      text-gray-700
      dark:text-gray-300
      opacity-90
      flex
      flex-col
      items-center
      justify-center
      rounded
      ;

      div {
        &:first-child {
          @apply
          p-4
          text-center
          flex
          flex-col
          items-center
          justify-center
          ;
        }

        &:last-child {
          @apply mt-6;
        }

        svg {
          @apply
          w-10 h-10 fill-current block
          ;
        }
      }
    }

    &__body {
      @apply
      p-4
      ;

      img {
        @apply
        h-8
        inline-block
        my-2
        mr-2
        fill-current
        align-middle
        shadow
        grayscale
        hover:grayscale-0
        ;
      }
    }

    &__header {
      @apply
      border-b
      border-gray-300
      dark:border-gray-500
      pb-2
      mb-2
      flex
      justify-between
      ;

      &__category {
        @apply
        justify-start
        ;

        > span {
          @apply
          inline-block
          bg-blue-400
          dark:bg-blue-400
          dark:bg-opacity-20
          rounded
          text-gray-50
          pl-1
          pr-1
          text-xs
          align-top
          ;
        }
      }

      &__statistics {
        @apply
        text-xs
        justify-end
        space-x-1
        ;

        > span {
          @apply
          inline-block
          text-xs
          text-gray-400
          dark:text-gray-400
          align-middle
          ;

          &:after {
            content: ' | ';
            @apply opacity-30;
          }

          &:last-child:after {
            content: '';
          }
        }

        &__icon {
          @apply
          inline-block
          w-3
          h-3
          fill-current
          text-xs
          text-gray-400
          dark:text-gray-400
          ;
        }
      }
    }

    &__footer {
      @apply
      border-t
      space-x-1
      dark:text-gray-300
      border-gray-300
      dark:border-gray-600
      bg-gray-200
      dark:bg-gray-500
      absolute
      right-0
      bottom-0
      p-2
      w-full
      text-right
      rounded-b;

      &__icon {
        @apply
        inline-block
        w-3
        h-3
        fill-current
        text-xs
        text-gray-400
        dark:text-gray-700
        ;
      }

      > span, > a {
        @apply
        inline-block
        text-xs
        text-gray-400
        dark:text-gray-700
        ;

        &:after {
          content: ' | ';
          @apply opacity-30;
        }

        &:last-child:after {
          content: '';
        }
      }

      > a {
        @apply font-bold;
      }
    }
  }
}
</style>
